using System;
using NUnitDemo.Demo_2;
using NUnit.Core;
using NUnit.Framework;
using NUnitDemo;

namespace UnitTests
{
	/// <summary>
	/// Summary description for Demo_2_TestSuit.
	/// </summary>
	[TestFixture]
	public class Demo_2_TestSuite
	{
		public Demo_2_TestSuite()
		{
		}

		[Suite]
		public static TestSuite GeometryTestSuite
		{
			get
			{
				TestSuite suite = new TestSuite("Geometric Class Tests");
				suite.Add(new Demo_2_TestTriangle());
				suite.Add(new Demo_2_TestSquare());

				return suite;
			}
		}
	}

	#region Triangle Test Class
	
	[TestFixture]
	public class Demo_2_TestTriangle
	{
		public Demo_2_TestTriangle(){}

		private Triangle triangle;

		[TestFixtureSetUp]
		public void SetUpMembers()
		{
			triangle = new Triangle();
		}

		[TestFixtureTearDown]
		public void DisposeMembers()
		{
			// Dispose & Close methods...
		}

		[Test]
		public void TestArea()
		{
			// Test Triangle Areas : 
			int area_1 = triangle.GetArea(5,4);
			Assert.AreEqual(10, area_1);

			int area_2 = triangle.GetArea(8,2);
			Assert.AreEqual(8, area_2);
		}

		[Test]
		public void TestPerimeter()
		{
			// Test Triangle Perimeters : 
			int perimeter_1 = triangle.GetPerimeter(3,4,5);
			Assert.AreEqual(12, perimeter_1);

			int perimeter_2 = triangle.GetPerimeter(8,2,5);
			Assert.AreEqual(15, perimeter_2);
		}
	}
	
	#endregion

	#region Square Test Class
	
	[TestFixture]
	public class Demo_2_TestSquare
	{
		public Demo_2_TestSquare(){}

		private Square square;

		[TestFixtureSetUp]
		public void WarmUpMembers()
		{
			int side = 6;
			square = new Square(side);
		}

		[Test]
		public void TestArea()
		{
			// Test square Area : 
			int area = square.GetArea();
			Assert.AreEqual(36, area);
		}

		[Test]
		public void TestPerimeter()
		{
			// Test square Perimeter : 
			int perimeter = square.GetPerimeter();
			Assert.AreEqual(24, perimeter);
		}
	}
	
	#endregion
}
