using System;
using NUnitDemo.Demo_3;
using NUnit.Framework;

namespace UnitTests
{
	/// <summary>
	/// Summary description for Demo_3_Category.
	/// </summary>
	[TestFixture]
	public class Demo_3_Category
	{
		public Demo_3_Category(){}

		private Square square;
		private Triangle triangle;

		[TestFixtureSetUp]
		public void SetUpMembers()
		{
			triangle = new Triangle();

			int side = 6;
			square = new Square(side);
		}

		[TestFixtureTearDown]
		public void DisposeMembers()
		{
			// Dispose & Close methods...
		}

		[Test]
		[Category("Areas")]
		public void TestTriangleArea()
		{
			// Test Triangle Areas : 
			int area_1 = triangle.GetArea(5,4);
			Assert.AreEqual(10, area_1);

			int area_2 = triangle.GetArea(8,2);
			Assert.AreEqual(8, area_2);
		}

		[Test]
		[Category("Perimeters")]
		public void TestTrianglePerimeter()
		{
			// Test Triangle Perimeters : 
			int perimeter_1 = triangle.GetPerimeter(3,4,5);
			Assert.AreEqual(12, perimeter_1);

			int perimeter_2 = triangle.GetPerimeter(8,2,5);
			Assert.AreEqual(15, perimeter_2);
		}

		[Test]
		[Category("Areas")]
		public void TestSquareArea()
		{
			// Test square Area : 
			int area = square.GetArea();
			Assert.AreEqual(36, area);
		}

		[Test]
		[Category("Perimeters")]
		public void TestSquarePerimeter()
		{
			// Test square Perimeter : 
			int perimeter = square.GetPerimeter();
			Assert.AreEqual(24, perimeter);
		}
	}
}
