using System;
using DotNetMock;
using NUnitDemo.Demo_5;
using NUnit.Framework;

namespace UnitTests
{
	/// <summary>
	/// Summary description for Demo_5_MockObjects.
	/// </summary>
	[TestFixture]
	public class Demo_5_MockObjects
	{
		public Demo_5_MockObjects()
		{
		}

		[Test]
		public void TestWithMockObject()
		{
			MockConnection conn = new MockConnection();
			string mesaj = "mock deneme";
			// Beklediimiz mesajlar beklediimiz srada Mock nesnemize ekliyoruz : 
			conn.AddExpectedMessage("Balant ald.");
			conn.AddExpectedMessage(mesaj + " - mesaj gnderildi.");
			conn.AddExpectedMessage("Balant kapatld.");

			Client client = new Client(conn);
			// Testimizi yapyoruz :
			client.SendMessage(mesaj);

			// Mesajlar doruluyoruz : 
			conn.Verify();
		}
	}

	public class MockConnection : MockObject, IConnection
	{
		public MockConnection()
		{
			_expectations = new ExpectationArrayList("MockConnection");
		}

		private ExpectationArrayList _expectations;

		public void Open()
		{
			_expectations.AddActual("Balant ald.");
		}

		public void Close()
		{
			_expectations.AddActual("Balant kapatld.");
		}

		public void SendMessage(string message)
		{
			_expectations.AddActual(message + " - mesaj gnderildi.");
		}

		// Umulan mesajlar eklemek iin Aadaki metodu ekliyoruz : 
		public void AddExpectedMessage(string expectedMessage)
		{
			_expectations.AddExpected(expectedMessage);
		}

	}
}
